#include <stdio.h>
#include <ctype.h>
#include <sys/timeb.h>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Output.H>

// this is used to stop Esc from exiting the program:
int handle(int e) {
  return (e == FL_SHORTCUT); // eat all keystrokes
}


int main(int argc, char** argv) {
  int i;
  char buf1[256];
  char buf2[256];
  float beat = 0;
  float lt;
  float lb[128];
  struct timeb ti;
  int nbb = 16;

  Fl::add_handler(handle);
  Fl_Window *w = new Fl_Window(320,200);
  Fl_Output *o = new Fl_Output(10,10,300,25);
  Fl_Output *p = new Fl_Output(10,50,300,25);
  w->end();
  w->show(argc,argv);
  for (i=0; i<128;i++) {
	lb[i] = 0;
  }
  i = 0;
  for (;;) {
    Fl::wait();
    if (!w->visible()) break;
    
    int k = Fl::event_key(32);
    if (k) {
    	if (i > 127) i = 0;
  	ftime(&ti);
	lb[i] = ti.time * 1000 + ti.millitm;
	sprintf(buf2, "%f", 1 / ((lb[i] - lt) / 60000));
	lt = lb[i];
	p->value(buf2);
	int ii, k1, k2;
	beat = 0;
	for (ii=0; ii < nbb; ii++) {
		k1 = i - ii;
		k2 = i - ii - 1;
		if (k1 < 0) k1 = 128 + k1;
		if (k2 < 0) k2 = 128 + k2;
		beat += lb[k1] - lb[k2]; 
	}
	beat = nbb / (beat / 60000);
	sprintf(buf1, "%.2f", beat);
	o->value(buf1);
	i++;
    } 
    
  }
  return 0;
}

